commit 8d8b8ed7835a1a03932a8c90c7c725f9903450d5
Author: Richard Biener <rguenther@suse.de>
Date:   Sun Oct 13 11:42:27 2024 +0200

    tree-optimization/116481 - avoid building function_type[]
    
    The following avoids building an array type with function or method
    element type during diagnosing an array bound violation as this
    will result in an error, rejecting a program with a not too useful
    error message.  Instead build such array type manually.
    
            PR tree-optimization/116481
            * pointer-query.cc (build_printable_array_type):
            Build an array types with function or method element type
            manually to avoid bogus diagnostic.
    
            * gcc.dg/pr116481.c: New testcase.
    
    (cherry picked from commit 1506027347776a2f6ec5b92d56ef192e85944e2e)

diff --git a/gcc/pointer-query.cc b/gcc/pointer-query.cc
index ccf9d823870..002c8ed2162 100644
--- a/gcc/pointer-query.cc
+++ b/gcc/pointer-query.cc
@@ -2587,6 +2587,17 @@ array_elt_at_offset (tree artype, HOST_WIDE_INT off,
 tree
 build_printable_array_type (tree eltype, unsigned HOST_WIDE_INT nelts)
 {
+  /* Cannot build an array type of functions or methods without
+     an error diagnostic.  */
+  if (FUNC_OR_METHOD_TYPE_P (eltype))
+    {
+      tree arrtype = make_node (ARRAY_TYPE);
+      TREE_TYPE (arrtype) = eltype;
+      TYPE_SIZE (arrtype) = bitsize_zero_node;
+      TYPE_SIZE_UNIT (arrtype) = size_zero_node;
+      return arrtype;
+    }
+
   if (TYPE_SIZE_UNIT (eltype)
       && TREE_CODE (TYPE_SIZE_UNIT (eltype)) == INTEGER_CST
       && !integer_zerop (TYPE_SIZE_UNIT (eltype))
diff --git a/gcc/testsuite/gcc.dg/pr116481.c b/gcc/testsuite/gcc.dg/pr116481.c
new file mode 100644
index 00000000000..3ee6d747087
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/pr116481.c
@@ -0,0 +1,13 @@
+/* { dg-do compile } */
+/* { dg-options "-O2 -Warray-bounds" } */
+
+extern void tramp ();
+
+int is_trampoline (void* function) /* { dg-bogus "arrays of functions are not meaningful" } */
+{
+  void* tramp_address = tramp;
+  if (!(((unsigned long)function & 3) == 2))
+    return 0;
+  return (((long *) ((char*)function - 2))[0]
+	  == ((long *) ((char*)tramp_address-2))[0]); /* { dg-warning "outside array bounds" } */
+}

